/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package filter;

import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.geom.Path2D.Double;

/**
 *
 * Mike Markowski mike.ab3ap@gmail.com
 */
public class SlowShape extends Slow2D {

    double x, y;
    GeneralPath.Double p;

    public SlowShape() {
        super();
        p = new GeneralPath.Double();
    }

    public GeneralPath.Double getP() {
        return p;
    }

    public void setP(GeneralPath.Double p) {
        this.p = p;
    }

    public void moveTo(double x, double y) {
        p.moveTo(x, y);
    }

    public void lineTo(double x, double y) {
        p.lineTo(x, y);
    }

    public void closePath() {
        p.closePath();
    }

    public boolean contains(double x, double y) {
        return p.contains(x, y);
    }

    public void translate(double tx, double ty) {
        AffineTransform xf = new AffineTransform();
        xf.translate(tx, ty);
        p.transform(xf);
    }

    @Override
    public void draw(Graphics2D g2) {
        super.draw(g2);
        if (isFill()) {
            g2.fill(p);
        } else {
            g2.draw(p);
        }
    }

    @Override
    public String toString() {
        String s = "";
//        for (int i = 0; i < indentLevel; i++) {
//            s += " ";
//        }
        s += "shape(...)\n";
        return s;
    }
}
